%global pkg_name automation-eda-controller
%global pypi_name aap-eda
%global module_name aap_eda
%global pkg_user eda
%global ui_name aap-ui
%global assets_name controller-assets

%global aap_version 2.4
%global commitId 1c476e8a81407ef14b2304722b492aae3f00fe15
%global commitId_ui bd038302cb6c154601867c88cf67f1a7f1c688e4
%global commitId_assets 055ca6fc16d166d739a6b395dd7fe357b9b5e207

%global __requires_exclude .*django-ansible-base\\[channel-auth\\].*

%global common_description %{expand:
Event Driven Ansible for AAP}
%global common_summary %{expand: Event Driven Ansible for AAP}


Name:           %{pkg_name}
Version:        1.0.5
Release:        1%{?dist}
Summary:        %{common_summary}

License:        Apache-2.0
URL:            git@gitlab.cee.redhat.com:ansible/aap-eda-controller.git
Source0:        automation-eda-controller-1c476e8a81407ef14b2304722b492aae3f00fe15.tar.gz
Source1:        aap-ui-bd038302cb6c154601867c88cf67f1a7f1c688e4.tar.gz
Source2:        controller-assets-055ca6fc16d166d739a6b395dd7fe357b9b5e207.tar.gz
Source3:        js_bundled_dep.txt
Source10:       automation-eda-controller.service
Source11:       automation-eda-controller-worker@.service
Source12:       automation-eda-controller.socket
Source13:       automation-eda-controller-daphne.service
Source14:       automation-eda-controller-worker.target
Source15:       automation-eda-controller.target
Source16:       automation-eda-controller-scheduler.service
Source17:       automation-eda-controller-activation-worker@.service
Source18:       automation-eda-controller-activation-worker.target
Source20:       automation-eda-controller-tmpfiles.conf
Source21:       50-automation-eda-controller-rsyslog.conf
Source22:       automation-eda-controller-logrotate.conf

BuildArch:      noarch

BuildRequires:  nodejs-devel
BuildRequires:  npm
BuildRequires:  python%{python3_pkgversion}-devel
BuildRequires:  python%{python3_pkgversion}-rpm-macros
BuildRequires:  python%{python3_pkgversion}-setuptools
BuildRequires:  python%{python3_pkgversion}-pip
BuildRequires:  python%{python3_pkgversion}-wheel
BuildRequires:  python%{python3_pkgversion}-poetry-core
BuildRequires:  systemd

Requires:       automation-eda-controller-server = %{version}-%{release}
Requires:       automation-eda-controller-ui = %{version}-%{release}
Requires:       crun
Requires:       logrotate
Requires:       podman
Requires:       postgresql
# SELinux requirements
Requires:       python3-libsemanage
Requires:       redis
Requires:       rsyslog
Requires:       systemd

%description
%{common_description}

%package server

Summary:        Event Driven Ansible Server and API

Requires:       ansible-automation-platform-common = %{aap_version}
Requires:       git-core
Requires:       python%{python3_pkgversion}-channels+daphne
Requires:       python%{python3_pkgversion}-cryptography
Requires:       python%{python3_pkgversion}-django >= 4.2
Requires:       python%{python3_pkgversion}-django < 4.3
Requires:       python%{python3_pkgversion}-djangorestframework
Requires:       python%{python3_pkgversion}-djangorestframework-simplejwt
Requires:       python%{python3_pkgversion}-django-ansible-base+authentication
Requires:       python%{python3_pkgversion}-django-ansible-base+channel_auth
Requires:       python%{python3_pkgversion}-django-filter
Requires:       python%{python3_pkgversion}-django-rq
Requires:       python%{python3_pkgversion}-django-split-settings >= 1.2.0
Requires:       python%{python3_pkgversion}-django-split-settings < 2.0
Requires:       python%{python3_pkgversion}-drf-spectacular
Requires:       python%{python3_pkgversion}-dynaconf >= 3.1
Requires:       python%{python3_pkgversion}-gunicorn
Requires:       python%{python3_pkgversion}-jinja2
Requires:       python%{python3_pkgversion}-kubernetes
Requires:       python%{python3_pkgversion}-podman >= 3:4.5
Requires:       python%{python3_pkgversion}-psycopg2
Requires:       python%{python3_pkgversion}-pydantic
Requires:       python%{python3_pkgversion}-rq
Requires:       python%{python3_pkgversion}-rq-scheduler >= 0.10.0
Requires:       python%{python3_pkgversion}-rq-scheduler < 1.0.0

%description server
Event Driven Ansible for AAP server and API

%package ui

Summary:        Event Driven Ansible UI

Requires:       ansible-automation-platform-common = %{aap_version}
Requires:       nginx >= 1:1.18.0

# JS dependencies
%include %{SOURCE3}

%description ui
Event Driven Ansible for AAP UI

%prep
%setup -q -T -b 1 -n %{ui_name}-%{commitId_ui}
%setup -q -T -b 2 -n %{assets_name}-%{commitId_assets}
%setup -q -n %{pkg_name}-%{commitId}

%py3_shebang_fix src/aap_eda

%build
%{__python3} -m pip config set global.index https://repository.engineering.redhat.com/nexus/repository/pypi.org/pypi
%{__python3} -m pip config set global.index_url https://repository.engineering.redhat.com/nexus/repository/pypi.org/simple
%{__python3} -m pip config set global.trusted-host repository.engineering.redhat.com
%{__python3} -m pip install setuptools==65.5.1

# build server
# Taken from pyproject-rpm-macros's 'pyproject_wheel'
%{__python3} -m pip wheel --wheel-dir %{_builddir}/wheeldir --no-deps --use-pep517 --no-build-isolation --disable-pip-version-check --no-clean --progress-bar off --verbose .

# init npm
npm_registry_override="https://repository.engineering.redhat.com/nexus/repository/registry.npmjs.org/"
npm config set registry ${npm_registry_override}
npm config set strict-ssl false

# build ui
cd %{_builddir}/%{ui_name}-%{commitId_ui}

cp %{_builddir}/%{assets_name}-%{commitId_assets}/awx/ui/client/assets/* frontend/icons/
cp -f %{_builddir}/%{assets_name}-%{commitId_assets}/awx/ui/client/assets/brand-logo.svg frontend/eda/main/eda-logo.svg

export BRAND="Red Hat"
export PRODUCT="Event-Driven Ansible controller"
export VERSION=%{version}

CYPRESS_INSTALL_BINARY=0 npm install --build-from-source
npm run build:eda

%install

install -m 0755 -vd                     %{buildroot}%{_unitdir}

# add system unit files
install -m 644 %{SOURCE10}              %{buildroot}%{_unitdir}
install -m 644 %{SOURCE11}              %{buildroot}%{_unitdir}
install -m 644 %{SOURCE12}              %{buildroot}%{_unitdir}
install -m 644 %{SOURCE13}              %{buildroot}%{_unitdir}
install -m 644 %{SOURCE14}              %{buildroot}%{_unitdir}
install -m 644 %{SOURCE15}              %{buildroot}%{_unitdir}
install -m 644 %{SOURCE16}              %{buildroot}%{_unitdir}
install -m 644 %{SOURCE17}              %{buildroot}%{_unitdir}
install -m 644 %{SOURCE18}              %{buildroot}%{_unitdir}

# add tmpfiles.d for socket files
install -m 0755 -vd                     %{buildroot}%{_sysconfdir}/tmpfiles.d
install -m 640 %{SOURCE20}              %{buildroot}%{_sysconfdir}/tmpfiles.d/automation-eda-controller.conf

# add rsyslog config
install -m 0755 -vd                     %{buildroot}%{_sysconfdir}/rsyslog.d
install -m 644 %{SOURCE21}              %{buildroot}%{_sysconfdir}/rsyslog.d/50-automation-eda-controller.conf

# add logrotate config
install -m 0755 -vd                     %{buildroot}%{_sysconfdir}/logrotate.d
install -m 644 %{SOURCE22}              %{buildroot}%{_sysconfdir}/logrotate.d/automation-eda-controller

# add configuration directory
mkdir -p %{buildroot}%{_sysconfdir}/ansible-automation-platform/eda

# add EDA shared state, media, and home dir
mkdir -p %{buildroot}%{_sharedstatedir}/ansible-automation-platform/eda/media

# add log directory
mkdir -p %{buildroot}%{_localstatedir}/log/ansible-automation-platform/eda

#install ui
mkdir -p %{buildroot}%{_sharedstatedir}/ansible-automation-platform/eda/ui
cp -a %{_builddir}/%{ui_name}-%{commitId_ui}/build/eda/* %{buildroot}%{_sharedstatedir}/ansible-automation-platform/eda/ui

# add directory for sockets
mkdir -p %{buildroot}%{_rundir}/ansible-automation-platform/eda

#install server

# Taken from pyproject-rpm-macros's 'pyproject_wheel'
%{__python3} -m pip install --root %{buildroot} --no-deps --disable-pip-version-check --progress-bar off --verbose --ignore-installed --no-warn-script-location --no-index --no-cache-dir --find-links %{_builddir}/wheeldir %{pypi_name}==%{version}
sed -i 's/pip/rpm/' %{buildroot}/%{python3_sitelib}/%{module_name}-%{version}.dist-info/INSTALLER
rm -fv %{buildroot}/%{python3_sitelib}/%{module_name}-%{version}.dist-info/{RECORD,REQUESTED}

%pre server
getent group %{pkg_user} >/dev/null || groupadd -r %{pkg_user}
getent passwd %{pkg_user} >/dev/null || \
    useradd -r -g %{pkg_user} -d %{_sharedstatedir}/ansible-automation-platform/eda -s %{_bindir}/bash %{pkg_user}

%post
usermod -aG redis,nginx %{pkg_user}
systemctl restart rsyslog
systemctl restart logrotate

%postun
systemctl restart rsyslog
systemctl restart logrotate

%files
%defattr(-,root,root)
%{_unitdir}/automation-eda-controller.service
%{_unitdir}/automation-eda-controller-worker@.service
%{_unitdir}/automation-eda-controller-activation-worker@.service
%{_unitdir}/automation-eda-controller.socket
%{_unitdir}/automation-eda-controller-daphne.service
%{_unitdir}/automation-eda-controller-worker.target
%{_unitdir}/automation-eda-controller-activation-worker.target
%{_unitdir}/automation-eda-controller-scheduler.service
%{_unitdir}/automation-eda-controller.target
%attr(0755,%{pkg_user},nginx) %{_rundir}/ansible-automation-platform/eda
%{_sysconfdir}/tmpfiles.d/automation-eda-controller.conf
%{_sysconfdir}/rsyslog.d/50-automation-eda-controller.conf
%{_sysconfdir}/logrotate.d/automation-eda-controller
%{_localstatedir}/log/ansible-automation-platform/eda

%files ui
%defattr(-,root,root)
%doc ../../BUILD/%{ui_name}-%{commitId_ui}/README.md
%license ../../BUILD/%{ui_name}-%{commitId_ui}/LICENSE.md
%attr(0755,root,nginx) %{_sharedstatedir}/ansible-automation-platform/eda/ui

%files server
%defattr(-,root,root)
%doc README.md
%license LICENSE
%{_bindir}/aap-eda-manage
%{python3_sitelib}/%{module_name}
%{python3_sitelib}/%{module_name}-%{version}.dist-info
%attr(0755,%{pkg_user},%{pkg_user}) %{_sharedstatedir}/ansible-automation-platform/eda
%attr(0775,%{pkg_user},root) %{_sharedstatedir}/ansible-automation-platform/eda/media
%exclude %{_sharedstatedir}/ansible-automation-platform/eda/ui
%attr(0750,%{pkg_user},root) %{_sysconfdir}/ansible-automation-platform/eda

%changelog
* Wed Feb 21 2024 James Marshall <jamarsha@redhat.com> 1.0.5-1
- Bump release
- Fix CVE-2024-1657 (Insecure websocket used when interacting with EDA server)

* Fri Nov 10 2023 James Marshall <jamarsha@redhat.com> 1.0.3-1
- Bump release
- Fix product name and version in UI
- Remove ansible-rulebook installation requirement on API server
- Add scheduler service
- Split worker and activation queues

* Wed Aug 16 2023 James Marshall <jamarsha@redhat.com> 1.0.1-1
- Bump release
- Fixes CVE-2023-4380 (token exposed at importing project)

* Tue Jun 13 2023 James Marshall <jamarsha@redhat.com> 1.0.0-1
- Initial release
